<?php namespace Vankosoft\CmsBundle\Repository;

use Sylius\Bundle\ResourceBundle\Doctrine\ORM\EntityRepository;

/**
 * PagesRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class PagesRepository extends EntityRepository
{
    public function countTotal() 
    {
        $query = $this->getEntityManager()->createQuery( 'SELECT COUNT(p) FROM VSCmsBundle:Page p' );

        return $query->getSingleScalarResult();
    }
    
    public function find( $id, $lockMode = null, $lockVersion = null ): ?object
    {
        if( ! is_numeric( $id ) ) {
            return $this->findOneBy( [ 'slug' => $id ] );
        }
        
        return parent::find( $id, $lockMode, $lockVersion );
    }
    
    public function findBySlug( $slug )
    {
        return $this->findOneBy( ['slug'=> $slug] );
    }
    
    public function getCurrentVersion( $id, $locale, $logRepo )
    {
        $log    = $logRepo->findOneBy( ['objectClass' => $this->_entityName, 'objectId' => $id, 'locale' => $locale], ['version' => 'desc'] );
        
        return $log ? $log->getVersion() : null;
    }
}
